<template>
  <div
    v-if="loading"
    class="column flex-center"
  >
    <q-spinner-dots
      color="primary"
      size="24px"
      class="q-ma-md"
    />
  </div>

  <q-list
    v-else-if="soilDerived"
    separator
    class="derived-observations"
  >
    <template
      v-for="derivedObservationObject in sortedDerivedObservations"
      :key="'soil-derived-observation-'+derivedObservationObject.id"
    >
      <q-item>
        <q-item-section class="text-body2 text-grey">
          <q-item-label>
            {{ formatLabel(derivedObservationObject) }}:
          </q-item-label>
        </q-item-section>
        <q-item-section
          class="text-body2 text-black"
          side
        >
          <q-item-label lines="1">
            <span>{{ formatObservationResult(derivedObservationObject) }}</span>
          </q-item-label>
        </q-item-section>
      </q-item>
    </template>
  </q-list>

  <div v-else>
    <q-card-section class="text-body2 text-grey">
      <translate>
        No estimated soil data
      </translate>
    </q-card-section>
  </div>
</template>

<script>
import queryPlotSoilDerivedObjects from 'src/pages/holding-campaign/plot/graphql/queryPlotSoilDerivedObjects'
import { getI18nField } from 'src/services/translate'

export default {
  name: 'PlotSoilDerivedCard',
  props: {
    plotId: {
      type: Number,
      required: true
    }
  },
  computed: {
    loading () {
      return !this.plotSoilDerivedObjects && this.$apollo.queries.plotSoilDerivedObjects.loading
    },
    soilDerived () {
      return this.plotSoilDerivedObjects?.[0]
    },
    sortedDerivedObservations () {
      if (this.soilDerived?.derivedObservations) {
        return [...this.soilDerived.derivedObservations].sort((a, b) => {
          return a.observableProperty.label > b.observableProperty.label ? 1 : -1
        })
      } else {
        return []
      }
    }
  },
  apollo: {
    plotSoilDerivedObjects: {
      query: queryPlotSoilDerivedObjects,
      notifyOnNetworkStatusChange: true,
      variables () {
        return {
          plotId: this.plotId
        }
      }
    }
  },
  methods: {
    formatObservationResult (observation) {
      if (observation?.result?.label) {
        return observation.result.label.trim()
      } else if (typeof observation?.result?.value === 'number') {
        let formatted = observation.result.value.toFixed(2)
        if (observation.observableProperty.unitOfMeasure.id !== 'no_unit') {
          formatted += ' ' + getI18nField(observation.observableProperty.unitOfMeasure, 'symbol')
        }
        return formatted
      } else if (typeof observation?.result?.value === 'boolean') {
        return observation.result.value ? this.$gettext('Yes') : this.$gettext('No')
      } else if (typeof observation?.result?.value === 'string') {
        return observation.result.value.trim()
      }
    },
    formatLabel (observation) {
      return getI18nField(observation?.observableProperty, 'label')
    }
  }
}
</script>

<style scoped>
.derived-observations {
  overflow: auto;
  max-height: 240px;
}
</style>
